import { Chalk } from "chalk";
import { Logger, Colors, Spinner, ProgressBar } from "reg-suit-interface";
export declare type LogLevel = "verbose" | "info" | "silent";
export declare class RegLogger implements Logger {
    private _category;
    _level: LogLevel;
    _chalk: Chalk;
    constructor(_category?: string);
    fork(newCategory: string): RegLogger;
    setLevel(v: LogLevel): void;
    get colors(): Colors;
    set colors(_v: Colors);
    getSpinner(msg?: string): Spinner;
    getProgressBar(): ProgressBar;
    info(msg: string): void;
    warn(msg: string): void;
    error(obj: string | Error): void;
    verbose(msg: string, ...objects: any[]): void;
    get _prefix(): string;
}
export declare function createLogger(category?: string): RegLogger;
